# -*- coding: utf-8 -*-
#------------------------------------------------------------
# pelisalacarta - XBMC Plugin
# Canal para newpct1
# http://blog.tvalacarta.info/plugin-xbmc/pelisalacarta/
#------------------------------------------------------------
import urlparse,urllib2,urllib,re
import os, sys

from core import logger
from core import config
from core import scrapertools
from core.item import Item
import json

__category__ = "A"
__type__ = "generic"
__title__ = "Yify"
__channel__ = "yify"
__language__ = "EN"

import urlparse,urllib2,urllib,re
import os, sys

from core import logger
from core import config
from core import scrapertools
from core.item import Item
from servers import servertools

DEBUG = config.get_setting("debug")

HEADERS = []
HEADERS.append(["Accept-Language" , "es-ES,es;q=0.8,en-US;q=0.5,en;q=0.3"])
HEADERS.append(["Accept"          , "text/html,application/xhtml+xml,application/xml;q=0.9,*/*;q=0.8"])
HEADERS.append(["User-Agent" , "Mozilla/5.0 (Windows NT 6.1; WOW64; rv:39.0) Gecko/20100101 Firefox/39.0"])
HEADERS.append(["Cookie" , "yts_lang=eyJsYW5nIjoiZXMiLCJjaGFyIjoiZXMtZXMifQ%3D%3D"])

def isGeneric():
    return True

def mainlist(item):
    logger.info("[yify.py] mainlist")
    
    itemlist = []
    itemlist.append( Item(channel=__channel__, title="Peliculas"          , action="peliculas" , url="http://yts.to/browse-movies"))
    itemlist.append( Item(channel=__channel__, title="Por Calidad"        , action="calidad"   , url="http://yts.to/browse-movies"))
    itemlist.append( Item(channel=__channel__, title="Por Genero"         , action="genero" , url="http://yts.to/browse-movies"))
    itemlist.append( Item(channel=__channel__, title="Por Puntuacion"     , action="puntuacion" , url="http://yts.to/browse-movies"))
    itemlist.append( Item(channel=__channel__, title="Buscar..."          , action="search"    , url="http://yts.to/browse-movies/%s/all/all/0/latest" ))
    
    return itemlist

def search(item,texto):
    logger.info("[yify.py] search:" + texto)
    item.url = item.url % texto

    try:
        return peliculas(item)
	# Se captura la excepción, para no interrumpir al buscador global si un canal falla
    except:
        import sys
        for line in sys.exc_info():
            logger.error( "%s" % line )
        return []
        
def calidad(item):
    logger.info("[yify.py] calidad")
    itemlist = []
    data = scrapertools.cachePage(item.url, headers= HEADERS)
    data = scrapertools.get_match(data,'<select name="quality">(.*?)</select>')
    
    patron =  '<option value="([^"]+)".*?>([^<]+)</option>'
    matches = re.compile(patron,re.DOTALL).findall(data)

    for calidad, title in matches:
        itemlist.append( Item(channel=__channel__, action="peliculas", title=title , url="http://yts.to/browse-movies/0/"+calidad + "/all/0/latest" , folder=True))
        
    return itemlist

def genero(item):
    logger.info("[yify.py] genero")
    itemlist = []
    data = scrapertools.cachePage(item.url, headers= HEADERS)
    data = scrapertools.get_match(data,'<select name="genre">(.*?)</select>')
    
    patron =  '<option value="([^"]+)".*?>([^<]+)</option>'
    matches = re.compile(patron,re.DOTALL).findall(data)

    for genero, title in matches:
        itemlist.append( Item(channel=__channel__, action="peliculas", title=title , url="http://yts.to/browse-movies/0/all/"+genero+"/0/latest" , folder=True))
        
    return itemlist

def puntuacion(item):
    logger.info("[yify.py] puntuacion")
    itemlist = []
    data = scrapertools.cachePage(item.url, headers= HEADERS)
    data = scrapertools.get_match(data,'<select name="rating">(.*?)</select>')

    patron =  '<option value="([^"]+)".*?>([^<]+)</option>'
    matches = re.compile(patron,re.DOTALL).findall(data)

    for rating, title in matches:
        itemlist.append( Item(channel=__channel__, action="peliculas", title=title , url="http://yts.to/browse-movies/0/all/all/"+rating+"/latest" , folder=True))
        
    return itemlist

def peliculas(item):
    logger.info("[yify.py] peliculas")
    itemlist = []

    # Descarga la página
    data = scrapertools.cachePage(item.url, headers= HEADERS)
    
    patron =  '<div class="browse-movie-wrap col-xs-10 col-sm-4 col-md-5 col-lg-4">  '
    patron += '<a href="([^"]+)" class="browse-movie-link"> '
    patron += '<figure> <img class="img-responsive" src="([^"]+)" alt="[^"]+" />  '
    patron += '<figcaption class="hidden-xs hidden-sm"> <span class="icon-star"></span> <h4 class="rating">([^<]+) / 10</h4> '
    patron += '(.*?)'
    patron += '<span class="button-green-download-big">.*?'
    patron += '</figcaption> </figure> </a> <div class="browse-movie-bottom">   '
    patron += '<a href="[^"]+" class="browse-movie-title">([^<]+)</a> '
    patron += '<div class="browse-movie-year">([^<]+)</div>  <div class="browse-movie-tags">   '
    patron += '.*?'
    patron += '</div>  </div> </div>  '
    

    matches = re.compile(patron,re.DOTALL).findall(data)

    for scrapedurl, scrapedthumbnail, scrapedrating, scrapedcategory, scrapedtitle, scrapedyear in matches:

        categorias = scrapedcategory.replace("</h4>  ","").split("<h4>")
        categorias = ", ".join(categorias)[2:]
        plot= "Año: [COLOR orange][B]" + scrapedyear + "[/B][/COLOR] Rating: [COLOR orange][B]" + scrapedrating + "[/B][/COLOR] Categorias: [COLOR orange][B]" + categorias + "[/B][/COLOR]"
        plot = bbcode_kodi2html(plot)
        itemlist.append( Item(channel=__channel__, action="findvideos", title=scrapedtitle , url=scrapedurl , thumbnail=scrapedthumbnail , plot=plot , folder=True))

    #Extrae el paginador
    matches = re.compile('<a href="([^"]+)">Siguiente &raquo;</a>',re.DOTALL).findall(data)
    if len(matches):
        itemlist.append( Item(channel=__channel__, action="peliculas", title="Página siguiente >>" , url=matches[0] , folder=True) )

    return itemlist
    
def bbcode_kodi2html(text):
    if config.get_platform().startswith("plex") or config.get_platform().startswith("mediaserver"):
        import re
        text = re.sub(r'\[COLOR\s([^\]]+)\]',
                      r'<span style="color: \1">',
                      text)
        text = text.replace('[/COLOR]','</span>')
        text = text.replace('[CR]','<br>')
        text = re.sub(r'\[([^\]]+)\]',
                      r'<\1>',
                      text)
        text = text.replace('"color: white"','"color: auto"')

    return text
    
def findvideos(item):
    logger.info("[yify.py] findvideos")
    itemlist = []

    data = scrapertools.cache_page(item.url, headers= HEADERS)
    
    plot = scrapertools.get_match(data,'<p class="hidden-xs"> (.*?) </p> ')
    descargas = scrapertools.get_match(data,'<div class="modal-content">  <div class="modal-torrent"> (.*?)</div> </div> </div>')
    
    
    patron =  '<div class="modal-quality" id="modal-quality-[^"]+"><span>([^<]+)</span></div> '
    patron += '<p>Tamaño del archivo</p> <p class="quality-size">([^<]+)</p> '
    patron += '<a download class="download-torrent button-green-download-big" href="([^"]+)"><span class="icon-in"></span>Descargar</a> '
    patron += '<a data-torrent-id="[^"]+" href="([^"]+)" class="magnet-download download-torrent magnet" title="Magnet Download"><span>Enláce magnético</span></a> </div>'    
    matches = re.compile(patron,re.DOTALL).findall(descargas)

    for calidad, tamano, torrent, magnet in matches:
        itemlist.append( Item(channel=__channel__, action="play", server="torrent", title="Descargar en .torrent (" + calidad + ")" , url=torrent, plot=plot, thumbnail=item.thumbnail, folder=False))
        itemlist.append( Item(channel=__channel__, action="play", server="torrent", title="Descargar en magnet (" + calidad + ")" , url=magnet, plot=plot, thumbnail=item.thumbnail , folder=False))


    return itemlist